/**********************************************************
	I would first like to thank NEHE of http://nehe.gamedev.net
	I do not know you personally, and I have not contacted you in the past, but I have been
	reading your website for at least a year now.  IT IS GREAT!!!  I am giving you thanks for a number
	of reasons, one of which is the ease of which you explain your tutorails.  One other 
	reason is, without your framework, this project would not have been possible.  
	I took your framework, and LOOSELY wrapped it into a CWindow class.  It of course can be
	expounded upon, but the point is, I used your framework.  ALSO, I took the bitmap font writer tutorial
	and wrapped that into a singleton class I used for this project.  NEHE, without your website, my desire, and
	knowledge would not be where it is today.  THANK YOU and KEEP UP THE GREAT WORK..

	I would also like to give thanks to   http://www.puzzlesolver.com/seqential/rubik/cube/index.shtml

	The solution that this program uses can be found in the link above.  Following it step by step
	I translated the pictures and Notation into code, and the result is a program that can
	solve the rubiks cube from any solvable position, without the use of any file (to read how to make the twists)

	THIS SOLUTION IS FAR FROM OPTIMAL, BUT IT WAS PROBABLY THE EASIEST FROM A CODING PERSPECTIVE!

***********************************************************/

#include "stdafx.h"
#include "Window.h"
#include "RubiksCube.h"
#include "BMPFont.h"
#include <stdlib.h>
#include <time.h>

#define MORECUBES 10

CWindow* TheWindow;
CRubiksCube Cube;
CRubiksCube MoreCubes[MORECUBES];
float fZoom[MORECUBES];
//BMPFont* TextWriter;
const float g_fMoreCubesXRotationChange = 0.2f;
const float g_fMoreCubesYRotationChange = 0.3f;
const float g_fMoreCubesZRotationChange = 0.4f;


void ResetCube(CRubiksCube* TheCube, bool bAutoSolve = false);
void Draw();

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop
	bool	fullscreen=false;
	TheWindow = CWindow::GetInstance();
	
	// Ask The User Which Screen Mode They Prefer
	//if (MessageBox(NULL,"Would You Like To Run In Fullscreen Mode?", "Start FullScreen?",MB_YESNO|MB_ICONQUESTION)==IDNO)
	//{
	//	fullscreen=FALSE;							// Windowed Mode
	//}

	srand((unsigned)time(NULL));
	if (!TheWindow->CreateGLWindow("Rubik's Solver",640,480,16,fullscreen))
	{
		return 0;									// Quit If Window Was Not Created
	}

//	TextWriter = BMPFont::GetInstance(TheWindow->m_hDC);

	for (int x = 0; x < MORECUBES; x++)
	{
		MoreCubes[x].ResetCube();
//		MoreCubes[x].ScrambleCube();
		//MoreCubes[x].m_nCubeState = SOLVED;
		MoreCubes[x].SetCubeState(ROTATINGFACE);
		MoreCubes[x].SetPrevCubeState(MAKEBOTTOMCROSS);
		MoreCubes[x].GenerateSolution();
		MoreCubes[x].SetAutoSolve(true);
		MoreCubes[x].SetAlpha(0.3f);
		fZoom[x] = -50.0f;
	}

	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			DWORD dwFirstTime = GetTickCount();
			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if (TheWindow->m_bActive)								// Program Active?
			{
				if (TheWindow->m_bKeys[VK_ESCAPE])				// Was ESC Pressed?
				{
					done=TRUE;						// ESC Signalled A Quit
				}
				else								// Not Time To Quit, Update Screen
				{
					Cube.Update();
					for (int x = 0; x < MORECUBES; x ++)
					{
						MoreCubes[x].Update();
						MoreCubes[x].SetXRotation(MoreCubes[x].GetXRotation() + ((rand() % 15) + 1) / (float) 10);
						MoreCubes[x].SetYRotation(MoreCubes[x].GetYRotation() + ((rand() % 15) + 1) / (float) 10);
						MoreCubes[x].SetZRotation(MoreCubes[x].GetZRotation() + ((rand() % 15) + 1) / (float) 10);
					}
					Draw();

					if (Cube.GetCubeState() == SOLVED)
					{
						Cube.SetAutoSolve(false);
					}
				}
			}

			if (TheWindow->m_bKeys[VK_LEFT])
			{
				Cube.SetYRotation(Cube.GetYRotation() - ROTATIONSPEED);
			}

			if (TheWindow->m_bKeys[VK_RIGHT])
			{
				Cube.SetYRotation(Cube.GetYRotation() + ROTATIONSPEED);
			}

			if (TheWindow->m_bKeys[VK_UP])
			{
				Cube.SetZRotation(Cube.GetZRotation() + ROTATIONSPEED);
			}

			if (TheWindow->m_bKeys[VK_DOWN])
			{
				Cube.SetZRotation(Cube.GetZRotation() - ROTATIONSPEED);
			}	
			
			if (TheWindow->m_bKeys[VK_NUMPAD8])
			{
				if (Cube.GetRotationSpeed() < 15.0f)
				{
					Cube.SetRotationSpeed(Cube.GetRotationSpeed() + 0.015f);
				}
			}

			if (TheWindow->m_bKeys[VK_NUMPAD2])
			{
				if (Cube.GetRotationSpeed() > 1.0f)
				{
					Cube.SetRotationSpeed(Cube.GetRotationSpeed() - 0.015f);
				}
			}

			if (TheWindow->m_bKeys[VK_NUMPAD4])
			{
				for (int x = 0; x < MORECUBES; x++)
				{
					if (MoreCubes[x].GetRotationSpeed() > 1.0f)
					{
						MoreCubes[x].SetRotationSpeed(MoreCubes[x].GetRotationSpeed() - 0.015f);
					}
				}
			}

			if (TheWindow->m_bKeys[VK_NUMPAD6])
			{
				for (int x = 0; x < MORECUBES; x++)
				{
					if (MoreCubes[x].GetRotationSpeed() < 15.0f)
					{
						MoreCubes[x].SetRotationSpeed(MoreCubes[x].GetRotationSpeed() + 0.015f);
					}
				}
			}

			if (TheWindow->m_bKeys[VK_F1])						// Is F1 Being Pressed?
			{
				TheWindow->m_bKeys[VK_F1]=FALSE;					// If So Make Key FALSE
				TheWindow->KillGLWindow();						// Kill Our Current Window
				TheWindow->m_bFullScreen = !TheWindow->m_bFullScreen;				// Toggle Fullscreen / Windowed Mode
				// Recreate Our OpenGL Window
				if (!TheWindow->CreateGLWindow("Rubik's Solver",640,480,16,TheWindow->m_bFullScreen))
				{
					return 0;						// Quit If Window Was Not Created
				}
				//release the BMPFont pointer, so that it will be recreated on the next call
				BMPFont::ReleasePointer();
			}

			if(TheWindow->m_bKeys['Q'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()) )
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);
					
					CMove aMove;
					aMove.m_bClockwise = false;
					aMove.m_nFaceToMove = FRONT;
					Cube.m_ListOfMoves.push_front(aMove);
				}
			}

			if(TheWindow->m_bKeys['W'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()))
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);

					CMove aMove;
					aMove.m_bClockwise = true;
					aMove.m_nFaceToMove = FRONT;
					Cube.m_ListOfMoves.push_front(aMove);
				}
			}

			if(TheWindow->m_bKeys['A'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()))
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);

					CMove aMove;
					aMove.m_bClockwise = true;
					aMove.m_nFaceToMove = LEFT;
					Cube.m_ListOfMoves.push_front(aMove);
				}
			}

			if(TheWindow->m_bKeys['S'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()))
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);

					CMove aMove;
					aMove.m_bClockwise = false;
					aMove.m_nFaceToMove = LEFT;
					Cube.m_ListOfMoves.push_front(aMove);
				}
			}

			if(TheWindow->m_bKeys['Z'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()) )
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);

					CMove aMove;
					aMove.m_bClockwise = true;
					aMove.m_nFaceToMove = TOP;
					Cube.m_ListOfMoves.push_front(aMove);
				}
			}

			if(TheWindow->m_bKeys['X'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()) )
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);

					CMove aMove;
					aMove.m_bClockwise = false;
					aMove.m_nFaceToMove = TOP;
					Cube.m_ListOfMoves.push_front(aMove);
				}
			}

			if(TheWindow->m_bKeys['E'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()) )
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);

					CMove aMove;
					aMove.m_bClockwise = true;
					aMove.m_nFaceToMove = BACK;
					Cube.m_ListOfMoves.push_front(aMove);
				}
			}

			if(TheWindow->m_bKeys['R'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()) )
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);
					
					CMove aMove;
					aMove.m_bClockwise = false;
					aMove.m_nFaceToMove = BACK;
					Cube.m_ListOfMoves.push_front(aMove);

				}
			}

			if(TheWindow->m_bKeys['D'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()) )
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);
					
					CMove aMove;
					aMove.m_bClockwise = true;
					aMove.m_nFaceToMove = RIGHT;
					Cube.m_ListOfMoves.push_front(aMove);
				}
			}

			if(TheWindow->m_bKeys['F'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()) )
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);

					CMove aMove;
					aMove.m_bClockwise = false;
					aMove.m_nFaceToMove = RIGHT;
					Cube.m_ListOfMoves.push_front(aMove);					
				}
			}

			if(TheWindow->m_bKeys['C'])
			{//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()) )
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);

					CMove aMove;
					aMove.m_bClockwise = true;
					aMove.m_nFaceToMove = BOTTOM;
					Cube.m_ListOfMoves.push_front(aMove);
				}
			}

			if(TheWindow->m_bKeys['V'])
			{	//only set a rotating face if there is not one currently
				if(-1 == Cube.GetRotatingFace() && (!Cube.IsAutoSolve()) )
				{
					Cube.SetPrevCubeState(Cube.GetCubeState());
					Cube.SetCubeState(ROTATINGFACE);

					CMove aMove;
					aMove.m_bClockwise = false;
					aMove.m_nFaceToMove = BOTTOM;
					Cube.m_ListOfMoves.push_front(aMove);
				}
			}

			if(TheWindow->m_bKeys['M'])
			{
				Cube.SetAutoSolve(!Cube.IsAutoSolve());
				
				if (Cube.IsAutoSolve())
				{
					//we just went back into automode, so act like
					//we need to start from scratch in the solving process
					Cube.SetCubeState(ROTATINGFACE);
					Cube.SetPrevCubeState(MAKEBOTTOMCROSS);

					Cube.m_ListIterator = NULL;
					Cube.m_ListOfMoves.clear();
					Cube.GenerateSolution();
				}
				else
				{
					Cube.SetCubeState(ROTATINGFACE);
					Cube.SetPrevCubeState(MAKEBOTTOMCROSS);

					Cube.m_ListIterator = NULL;
					Cube.m_ListOfMoves.clear();
				}
				TheWindow->m_bKeys['M'] = false;
			}

			if(TheWindow->m_bKeys[' '])
			{
				TheWindow->m_bKeyPressed[' '] = true;
				ResetCube(&Cube);
			}

			DWORD dwLastTime = GetTickCount();
			while (dwLastTime - dwFirstTime < 17)
			{
				dwLastTime = GetTickCount();
			}
		}
	}
	BMPFont::ReleasePointer();
	return (msg.wParam);							// Exit The Program
}

__forceinline void Draw()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
	glLoadIdentity();									// Reset The Current Modelview Matrix

	glPushMatrix();
		glTranslatef(0.0, 0.0, -15.0);
		glDisable(GL_BLEND);
		Cube.Draw();
		glEnable(GL_BLEND);
	glPopMatrix();
	
	int y = 0;
	for (int x = 0; x < MORECUBES; x++)	
	{
		//const float XLoc[5] = {-25.0, -15.0, -5.0, 15.0, 25.0};
		const float XLoc[5] = {-22.0, -11.0, 0.0, 11.0, 22.0};
		const float YLoc[2] = {-15.0, 15.0};
		float fLocalXDisp = 0.0f, fLocalYDisp = 0.0f;

		glPushMatrix();	
			
			if (MoreCubes[y].GetCubeState() == SOLVED)
			{
				fZoom[y] -= 1.0f;
				if (fZoom[y] < -150.0f)
				{
					ResetCube(&MoreCubes[y], true);
				}
			}

			if (MoreCubes[y].GetCubeState() != SOLVED && fZoom[y] < -50.0f)
			{
				fZoom[y] += 2.0f;
				if (fZoom[y] > -50.0f)
				{
					fZoom[y] = -50.0f;
				}
			}

			glTranslatef(XLoc[(x / 2)], YLoc[(x % 2)], fZoom[x]);
			MoreCubes[y].Draw();
		glPopMatrix();
		y++;
	}
	glColor3fv(CColors::GetColor(WHITE));

	glDisable(GL_BLEND);
	char szModeMessage[50];
	sprintf(szModeMessage, "Auto solve is %s", ((Cube.IsAutoSolve()) ? "ON" : "OFF"));

	glPushMatrix();
		glTranslatef(0.0, 0.0, -1.0);
		glRasterPos2f(-0.55f,0.35f);
		BMPFont::GetInstance(TheWindow->m_hDC)->glPrint(szModeMessage);
	glPopMatrix();

	if (Cube.IsAutoSolve())
	{
		char szMovesRemaining[50];
		sprintf(szMovesRemaining, "Moves Remaining: %d", Cube.m_ListOfMoves.size());

		glPushMatrix();
			glTranslatef(0.0, 0.0, -1.0);
			glRasterPos2f(-0.55f,-0.40f);
			BMPFont::GetInstance(TheWindow->m_hDC)->glPrint(szMovesRemaining);
		glPopMatrix();
	}

#ifdef _DEBUG
	glColor4fv(CColors::GetRed());
	char szRotationSpeed[50];
	sprintf(szRotationSpeed, "Rotation Speed: %13.7f", Cube.GetRotationSpeed());
	glPushMatrix();
		glTranslatef(0.0, 0.0, -1.0);
		glRasterPos2f(-0.55f,-0.30f);
		TextWriter->glPrint(szRotationSpeed);
	glPopMatrix();		
#endif

	glEnable(GL_BLEND);
	SwapBuffers(TheWindow->m_hDC);				// Swap Buffers (Double Buffering)
}

void ResetCube(CRubiksCube* TheCube, bool bAutoSolve)
{
	TheCube->ResetCube();

	if (bAutoSolve)
	{
		TheCube->SetCubeState(ROTATINGFACE);
		TheCube->SetPrevCubeState(MAKEBOTTOMCROSS);

		TheCube->m_ListIterator = NULL;
		TheCube->m_ListOfMoves.clear();
		TheCube->GenerateSolution();
		TheCube->SetAlpha(0.3f);
		//TheCube->m_fRotationSpeed=	8.5f;
	}
}